package edu.br.usp.ime.business.cu_gestionarusuario;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import edu.br.usp.ime.business.cu_autenticarusuario.data.dto.UsuarioDTO;
import edu.br.usp.ime.business.cu_gestionarusuario.data.GestionarUsuarioDAO;
import edu.br.usp.ime.modelo.EstadoUsuario;
import edu.br.usp.ime.modelo.Rol;
import edu.br.usp.ime.modelo.Usuario;

public class GestionarUsuarioImpl implements GestionarUsuario {
	
	GestionarUsuarioDAO dao;	
	protected final Log log = LogFactory.getLog(getClass());
	
	
	public void registarUsuario( UsuarioDTO userDTO ){
	
        if (log.isDebugEnabled()) {
            log.debug("Inicia - registarUsuario");
        }
        
        EstadoUsuario estadoUsuario = new EstadoUsuario();
        estadoUsuario.setIdestadousuario(userDTO.getEstadoUsuario());
        
        Usuario usuarioCriador = new Usuario();
        usuarioCriador.setIdusuario(userDTO.getUsuarioCriador());
        
        Usuario usuarioModificador = new Usuario();
        usuarioModificador.setIdusuario(userDTO.getOperadorModificador());
        
        Rol rol = new Rol();
        rol.setIdrol(1);
        
		Usuario usuario = new Usuario();
		usuario.setCodUsuario(userDTO.getCodUsuario());
		usuario.setDataModificacao(new Date());
		usuario.setEmail(userDTO.getEmail());
		usuario.setEndereco(userDTO.getEndereco());
		usuario.setEstadoUsuario(estadoUsuario);
		usuario.setNome(userDTO.getNome());
		usuario.setNumeroUsp(userDTO.getNumeroUsp());
		usuario.setRol(rol);
		usuario.setSenha(userDTO.getSenha());
		usuario.setSobrenome(userDTO.getSobrenome());
		usuario.setTelefone(userDTO.getTelefone());
		usuario.setUsuarioCriador(usuarioCriador);
		usuario.setOperadorModificador(usuarioModificador);
		
		dao.saveObject(usuario);
		
	}
	
	public UsuarioDTO obterUsuario( String codigoUsuario){
		
        if (log.isDebugEnabled()) {
            log.debug("Inicia - obterUsuario");
        }
		
        Usuario usuario = dao.obterUsuario(codigoUsuario);
        
        int estadoUsuario = usuario.getEstadoUsuario().getIdestadousuario();
        int usuarioCriador = usuario.getUsuarioCriador().getIdusuario();
        int usuarioModificador = usuario.getOperadorModificador().getIdusuario();
        int rol = usuario.getRol().getIdrol();
        
        UsuarioDTO usuarioDTO = new UsuarioDTO();
        usuarioDTO.setCodUsuario(usuario.getCodUsuario());
        usuarioDTO.setDataModificacao(usuario.getDataModificacao());
        usuarioDTO.setEmail(usuario.getEmail());
        usuarioDTO.setEndereco(usuario.getEndereco());
        usuarioDTO.setEstadoUsuario(estadoUsuario);
        usuarioDTO.setNome(usuario.getNome());
        usuarioDTO.setNumeroUsp(usuario.getNumeroUsp());
        usuarioDTO.setRol(rol);
        usuarioDTO.setSenha(usuario.getSenha());
        usuarioDTO.setSobrenome(usuario.getSobrenome());
        usuarioDTO.setTelefone(usuario.getTelefone());
        usuarioDTO.setUsuarioCriador(usuarioCriador);
        usuarioDTO.setOperadorModificador(usuarioModificador);
        
       
        return usuarioDTO;
	}
	
	public void atualizarUsuario( UsuarioDTO userDTO ){
		
		EstadoUsuario estadoUsuario = new EstadoUsuario();
        estadoUsuario.setIdestadousuario(userDTO.getEstadoUsuario());
        
        Usuario usuarioCriador = new Usuario();
        usuarioCriador.setIdusuario(userDTO.getUsuarioCriador());
        
        Usuario usuarioModificador = new Usuario();
        usuarioModificador.setIdusuario(userDTO.getOperadorModificador());
        
        Rol rol = new Rol();
        rol.setIdrol(1);
        
        if (log.isDebugEnabled()) {
            log.debug("Inicia - atualizarUsuario");
        }
        
		Usuario usuario = new Usuario();
		usuario.setCodUsuario(userDTO.getCodUsuario());
		usuario.setDataModificacao(new Date());
		usuario.setEmail(userDTO.getEmail());
		usuario.setEndereco(userDTO.getEndereco());
		usuario.setEstadoUsuario(estadoUsuario);
		usuario.setNome(userDTO.getNome());
		usuario.setNumeroUsp(userDTO.getNumeroUsp());
		usuario.setRol(rol);
		usuario.setSenha(userDTO.getSenha());
		usuario.setSobrenome(userDTO.getSobrenome());
		usuario.setTelefone(userDTO.getTelefone());
		usuario.setUsuarioCriador(usuarioCriador);
		usuario.setOperadorModificador(usuarioModificador);
		
		dao.updateObject(usuario);
		
	}
	
    public List<UsuarioDTO> obterUsuarios() {
    	   		    	   		
    	List<Usuario> lstUsuarios = dao.obterUsuarios();
    	
    	List<UsuarioDTO> lstUsuarioDTO = new ArrayList<UsuarioDTO>();
    	UsuarioDTO usuarioDTO = new UsuarioDTO();
    	
    	Iterator it = lstUsuarios.iterator();
    	while (it.hasNext()) {
			Usuario tmpUsuario = (Usuario) it.next();
			
			usuarioDTO.setCodUsuario(tmpUsuario.getCodUsuario());
	        usuarioDTO.setDataModificacao(tmpUsuario.getDataModificacao());
	        usuarioDTO.setEmail(tmpUsuario.getEmail());
	        usuarioDTO.setEndereco(tmpUsuario.getEndereco());
	        usuarioDTO.setEstadoUsuario(tmpUsuario.getEstadoUsuario().getIdestadousuario());
	        usuarioDTO.setNome(tmpUsuario.getNome());
	        usuarioDTO.setNumeroUsp(tmpUsuario.getNumeroUsp());
	        usuarioDTO.setRol(tmpUsuario.getRol().getIdrol());
	        usuarioDTO.setSenha(tmpUsuario.getSenha());
	        usuarioDTO.setSobrenome(tmpUsuario.getSobrenome());
	        usuarioDTO.setTelefone(tmpUsuario.getTelefone());
	        usuarioDTO.setUsuarioCriador(tmpUsuario.getUsuarioCriador().getIdusuario());
	        usuarioDTO.setOperadorModificador(tmpUsuario.getOperadorModificador().getIdusuario());
    		    		
			lstUsuarioDTO.add(usuarioDTO);
		}
    	return lstUsuarioDTO; 
    }
    
    public void apagarUsuario( int idUsuario){
       	dao.removeObject(Usuario.class, idUsuario);	
    }

    
    
	/**
	 * @return the dao
	 */
	public GestionarUsuarioDAO getDao() {
		return dao;
	}

	/**
	 * @param dao the dao to set
	 */
	public void setDao(GestionarUsuarioDAO dao) {
		this.dao = dao;
	}

	
}
