package edu.br.usp.ime.dao.impl;

import java.io.Serializable;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.orm.ObjectRetrievalFailureException;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import edu.br.usp.ime.dao.DAO;

public class HibernateDAO  extends HibernateDaoSupport implements DAO{
    protected final Log log = LogFactory.getLog(getClass());
    

    public void saveObject(Object o) {
        getHibernateTemplate().save(o);
    }
    

    public void updateObject(Object o) {
        getHibernateTemplate().update(o);
    }
    

    public void saveOrUpdateObject(Object o) {
        getHibernateTemplate().saveOrUpdate(o);
    }


    public Object getObject(Class clazz, Serializable id) {
        Object o = getHibernateTemplate().get(clazz, id);
        if (o == null) {
            throw new ObjectRetrievalFailureException(clazz, id);
        }
        return o;
    }
    

    public Object getObject(Class clazz, String code) {
        String className = clazz.getSimpleName();
        String query = "FROM " + className + " WHERE codigo=?";
        log.info(query);
        List<Object> objects = getHibernateTemplate().find(query, code);
        if (objects == null || objects.isEmpty()) {
            throw new ObjectRetrievalFailureException(clazz, code);
        } else {
            return objects.get(0);
        }
    }

    public List<Object> getObjects(Class clazz) {
        return getHibernateTemplate().loadAll(clazz);
    }


    public void removeObject(Class clazz, Serializable id) {
        getHibernateTemplate().delete(getObject(clazz, id));
    }
}
